#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>
#include <pcap.h>

struct iphdr
  {
#if __BYTE_ORDER == __LITTLE_ENDIAN
    u_int8_t ihl:4;
    u_int8_t version:4;
#elif __BYTE_ORDER == __BIG_ENDIAN
    u_int8_t    version:4;
    u_int8_t ihl:4;
#else
#error  "Please fix <bytesex.h>"
#endif
    u_int8_t tos;
    u_int16_t tot_len;
    u_int16_t id;
    u_int16_t frag_off;
    u_int8_t ttl;
    u_int8_t protocol;
    u_int16_t check;
    u_int32_t saddr;
    u_int32_t daddr;
    /*The options start here. */
  };

struct icmphdr
{
  u_int8_t type;                /* message type */
  u_int8_t code;                /* type sub-code */
  u_int16_t checksum;
  union
  {
    struct
    {
      u_int16_t id;
      u_int16_t sequence;
    } echo;                     /* echo datagram */
    u_int32_t   gateway;        /* gateway address */
    struct
    {
      u_int16_t unused;
      u_int16_t mtu;
    } frag;                     /* path mtu discovery */
  } un;
};

typedef struct iipkt {
struct iphdr ih;
struct icmphdr ich;
} IIPKT;

void
pkt_send (int fd, unsigned char * sock,u_char *pkt,int size)
{

  if (sendto (fd, (const void *)pkt,size, 0, (const struct sockaddr *) sock, siz
eof (struct sockaddr)) < 0)
    {
      close (fd);
      if (errno == EMSGSIZE) 
        croak("packet too big");
      else
        croak("sendto()");
    }
}

int main()
{
        int fd,val=1;

    
        if ((fd = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0) {
        printf("(rawsock) socket problems [fatal]");
        }  

        if (setsockopt(fd, IPPROTO_IP, IP_HDRINCL, &val, sizeof(val)) < 0) {  
       printf("Cannot set IP_HDRINCL socket option");
        }	

	pkt_send(fd, pkt, 0, sizeof(pkt));
}
