# Linux-specific code for setting firewall rules

package ActiveMap::Firewall::Linux;

use IPTables::IPv4::IPQueue qw(:constants);

sub set_tcp_firewall
  {
    my ($low_port, $high_port) = @_;

    my $cmd = "iptables -A INPUT -p tcp --destination-port $low_port:$high_port -j DROP";
    
    print "Make sure you have set an iptables rule to block traffic to TCP ports.\n".
      "Namely, $cmd\n");
  }


sub new
  {
    my $CLASS = shift;

    return bless $CLASS, {};
  }

1;
